# ContextBlock

### init

Creates an `ContextBlock` instance.

{% hint style="info" %}
Slack Docs: <https://api.slack.com/reference/block-kit/blocks#context>
{% endhint %}

<table><thead><tr><th width="164">Name</th><th width="229">Type</th><th>Required</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td>No arguments</td><td></td><td></td><td></td><td></td></tr></tbody></table>

**Return**: The `ContextBlock` instance.

### id

Sets a custom identifier for the `ContextBlock` instance.

<table><thead><tr><th width="151">Name</th><th width="229">Type</th><th>Required</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td><code>string</code></td><td>true</td><td></td><td>The custom identifier for the <code>ActionsBlock</code> instance.</td></tr></tbody></table>

**Return**: The `ContextBlock` instance.

### image

Adds an `ImageElement` to this `ContextBlock` instance.

{% content-ref url="/pages/MniWnBWSl009UuTe0ze3" %}
[ImageElement](/reference/baseprovider/slackprovider/slackmessage/imageelement.md)
{% endcontent-ref %}

<table><thead><tr><th width="164">Name</th><th width="149">Type</th><th width="94">Required</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td>imageUrl</td><td><code>string</code></td><td>true</td><td></td><td>The url for the image.</td></tr><tr><td>altText</td><td><code>string</code></td><td>false</td><td><code>""</code> (empty string)</td><td>The alt text for the image.</td></tr></tbody></table>

**Return**: The new `ImageElement` instance.

{% hint style="danger" %}
**Throws:** `Megaphone.Provider.SlackBlockException` when more than 25 elements are added.
{% endhint %}

### text

Adds a `TextObject` to this `ContextBlock` instance.

{% content-ref url="/pages/8nFSQtmXEIhi6IneZJ3r" %}
[TextObject](/reference/baseprovider/slackprovider/slackmessage/textobject.md)
{% endcontent-ref %}

<table><thead><tr><th width="164">Name</th><th width="149">Type</th><th width="94">Required</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td>text</td><td><code>string</code></td><td>true</td><td></td><td>The text for the <code>TextObject</code>.</td></tr></tbody></table>

**Return**: The new `TextObject` instance.

{% hint style="danger" %}
**Throws:** `Megaphone.Provider.SlackBlockException` when more than 25 elements are added.
{% endhint %}

### getMemento

Converts the `ContextBlock` instance to a serializable format.

<table><thead><tr><th width="181">Name</th><th width="229">Type</th><th>Required</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td>No arguments</td><td></td><td></td><td></td><td></td></tr></tbody></table>

**Return**: (`struct`) A struct representing this `ContextBlock` instance.

{% hint style="danger" %}
**Throws:** `Megaphone.Provider.SlackBlockException` when either 0 or more than 25 elements are present.
{% endhint %}

```cfscript
{
    "type": "context"
    "elements": [ ... ],
    "block_id": "optional"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://megaphone.ortusbooks.com/reference/baseprovider/slackprovider/slackmessage/contextblock.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
